/* ========================================================================== */
/*	             Exp04_1.c : Timer/Counter1 Interrupt(0.5Hz)	              */
/* ========================================================================== */
/*			  Designed and programmed by Jee-Hwan Ryu in 2005.  */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include "my_header.h"

// Declare your global variables here
unsigned char MotorNumber=0, Flag=1;
unsigned int TargetData[8], Data[8], Speed, CountValue;

unsigned int Ttable[3] = {11200, 24000, 36800};



SIGNAL(SIG_OVERFLOW1)                    /* OC1A interrupt function */
{
  // Place your code here
if (TargetData[MotorNumber] > Data[MotorNumber]) Data[MotorNumber] += Speed;
else if (TargetData[MotorNumber] < Data[MotorNumber]) Data[MotorNumber] -= Speed; 

if (Flag)
{
	PORTB = 0x01 << MotorNumber;
	CountValue = 0xffff - Data[MotorNumber];
	TCNT1H = CountValue >> 8;
	TCNT1L = CountValue & 0xff;
	Flag = 0;
} else {
	PORTB = 0x00;
	CountValue = 0xffff - (40000- Data[MotorNumber]);
	TCNT1H = CountValue >> 8;
	TCNT1L = CountValue & 0xff;
	MotorNumber++;
	MotorNumber %= 8;
	Flag = 1;
}

}

void init(void)
{
	unsigned char i;
	Speed = 800;
	for (i=0; i<8; i++)
	{
		TargetData[i] = Ttable[1];
	}
        
}
 
void left(void)
{
	unsigned char i;
	Speed = 800;
	for (i=0; i<8; i++)
	{
		TargetData[i] = Ttable[0];
	}
        
}
void right(void)
{   
	unsigned char i;
	Speed = 800;
	for (i=0; i<8; i++)
	{
		TargetData[i] = Ttable[2];
	}
        
}



int main(void)
{
  DDRB = 0xFF;

  TCCR1A = 0x00;                                // CTC mode(4), don't output OC1A
  TCCR1B = 0x01;                                // 16MHz
  TCCR1C = 0x00;

  TIMSK = 0x04;                                 // enable OC1A interrupt

 
  sei();                                        // global interrupt enable

  while(1)
	{
	// Place your code here 
      init();
      Delay_ms(1000);
	  
	  left();
	  Delay_ms(1000);
	  
	  right();
	  Delay_ms(1000);
	
	
	}
	
	
	// wait interrupt
}

